.\" Copyright (c) 1983, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)psignal.3	8.2 (Berkeley) 2/27/95
.\"
.Dd February 27, 1995
.Dt PSIGNAL 3
.Os BSD 4.2
.Sh NAME
.Nm psignal ,
.Nm sys_siglist ,
.Nm sys_signame
.Nd system signal messages
.Sh SYNOPSIS
.Fd #include <signal.h>
.Ft void
.Fn psignal "unsigned sig" "const char *s"
.Vt extern const char * const sys_siglist[];
.Vt extern const char * const sys_signame[];
.Sh DESCRIPTION
The
.Fn psignal
function locates the descriptive message
string for the given signal number
.Fa sig
and writes it to the standard error.
.Pp
If the argument
.Fa s
is
.Pf non- Dv NULL
it is written to the standard error file descriptor
prior to the message string,
immediately followed by a colon and a space.
If the signal number is not recognized
.Pq Xr sigaction 2 ,
the string
.Dq "Unknown signal
is produced.
.Pp
The message strings can be accessed directly
through the external array
.Va sys_siglist ,
indexed by recognized signal numbers.
The external array
.Va sys_signame
is used similarly and
contains short, lower-case abbreviations for signals
which are useful for recognizing signal names
in user input.
The defined variable
.Dv NSIG
contains a count of the strings in
.Va sys_siglist
and
.Va sys_signame .
.Sh SEE ALSO
.Xr sigaction 2 ,
.Xr perror 3
.Sh HISTORY
The
.Fn psignal
function appeared in 
.Bx 4.2 .
